from ..utils.error import errorBreakApi
from ..utils.microservices import Microservice
from ..utils.request import Request, GET


class AuthGateway:

    @classmethod
    def getPublicKey(cls, language, workspaceId=None, memberId=None):
        query = ""
        if workspaceId:
            query = "workspaceId={workspaceId}".format(workspaceId=workspaceId)
        if memberId:
            query = "memberId={memberId}".format(memberId=memberId)

        response = Request.fetch(
            url="{baseUrl}/auth/public-key?{query}".format(baseUrl=Microservice.getBaseUrl(Microservice.auth), query=query),
            method=GET,
            deadline=50
        )

        if response.status == 400:
            return None, response.contentJson()
        elif response.status > 200:
            return None, errorBreakApi(language=language)

        return response.contentJson().get("publicKey"), None